( function( )
{
	var _connector = new XConnector;
	var _script = new XScript;

	function Link( )
	{
		var _path = ( arguments.length && arguments[ 0 ].constructor == String ) ? arguments[ 0 ] : '/';
		var _last_request = null;

		var _before = null;
		var _after = null;

		if ( window.location.protocol + '//' + window.location.host + window.location.pathname != _path )
			window.location.href = _path + (
				( window.location.hash ) ?
					window.location.hash : '#' + String( window.location.protocol + '//' + window.location.host + window.location.pathname + window.location.search ).substr( _path.length )
			);

		function _click( _action, _cache )
		{
			if ( _action.indexOf( window.location.host ) < 0 )
				_action = window.location.protocol + '//' + window.location.host + _action;

			var _post = ( arguments.length == 3 && arguments[ 2 ] && arguments[ 2 ].constructor == String ) ? arguments[ 2 ] : null;

			if ( _post == null && _action == _last_request )
				return false;

			if ( _before )
				_before( );

			_connector.go(
			{
				'access' : _action,
				'cache' : _cache,
				'handler' : _handler,
				'post' : _post
			} );

			_last_request = _action;

			window.location = '#' + (
				( _action.indexOf( _path ) < 0 ) ?
					_action : _action.substr( _action.indexOf( _path ) + _path.length )
			);
		}

		function _intercept( pLink )
		{
			var action = pLink.href;
			if ( action == '' )
				return false;

			var a = ( action.indexOf( 'javascript:' ) === 0 );
			a = ( a || ( action.indexOf( '#' ) === 0 ) );
			a = ( a || ( action.indexOf( window.location + '#' ) === 0 ) );
			a = ( a || ! ( action.indexOf( 'workflow' ) < 0 ) );

			if ( ! a )
				pLink.onclick = function( )
				{
					var _cacheit = false;//( ( pLink.hasAttribute( 'cacheit' ) && pLink.getAttribute( 'cacheit' ) === 'true' ) ? true : false );

					_click( action, _cacheit );

					return false;
				};
		}

		function _handler( data )
		{
			var js = data.match( /<script[^>]*>.*?<\/script>/gi );
			if ( js )
			{
				var _tag = /<script([^>]*src="(\S+)"[^>]*|[^>]*)>(.*?)<\/script>/i;
				for ( var i = 0; i < js.length; i++ )
				{
					var _type = _tag.exec( js[ i ] );
					data = data.replace( _type[ 0 ], '' );

					if ( _type[ 2 ] == undefined || _type[ 2 ].length == 0 )
						_script.inline( _type[ 3 ] );
					else
					{
						if ( _type[ 2 ].indexOf( window.location.host ) < 0 )
							_type[ 2 ] = window.location.protocol + '//' + window.location.host + _type[ 2 ];

						_script.external(
							_type[ 2 ].substr(
								_path.length - 1,
								_type[ 2 ].length - _path.length + 1 - (
									( _type[ 2 ].indexOf( '?' ) < 0 ) ?
										0 : ( _type[ 2 ].length - _type[ 2 ].indexOf( '?' ) )
								)
							)
						);
					}
				}
			}

			var el = document.createElement( 'div' );
			el.innerHTML = data;

			var _links = el.getElementsByTagName( 'a' );
			for ( var i = 0; i < _links.length; i++ )
				_intercept( _links.item( i ) );

			if ( _after )
				_after( el );

			_script.load( );
		}

		function _manipulator( )
		{
			if ( arguments.length != 1 )
				return false;

			switch ( arguments[ 0 ].constructor )
			{
				case Function :
					_after = arguments[ 0 ];
					break;
				case Object :
					if ( ! ( ( arguments[ 0 ].before && arguments[ 0 ].before.constructor == Function ) && ( arguments[ 0 ].after && arguments[ 0 ].after.constructor == Function ) ) )
						return false;

					_before = arguments[ 0 ].before;
					_after = arguments[ 0 ].after;
					break;
				default : return false;
			}
		}

		this.click = function( )
		{
			_click( arguments[ 0 ],
				(
					( arguments.length > 1 && arguments[ 1 ] && arguments[ 1 ].constructor == Boolean ) ?
						arguments[ 1 ] : false
				),
				(
					( arguments.length > 2 && arguments[ 2 ] && arguments[ 2 ].constructor == String ) ?
						arguments[ 2 ] : null
				)
			);
		};

		this.intercept = _intercept;
		this.handler = _manipulator;
	}

	window.XLink = Link;
} )( );
